<template>
  <div class="dashboard-agency-banking-page pb-5">
    <h1 class="page-title">Agency Services</h1>
    <div class="mt-3">
      <!-- <h6>1. Choose a Card</h6> -->
      <div class="row">
        <div class="col-sm-12 col-md-4">
          <div class="mt-2">
            <div ref="transactionCount">
              <AgencyCountCard
                title="Transaction Count"
                :count="count.transactionCount"
              />
            </div>
          </div>
          <div class="mt-2">
            <div ref="totalCustomerCount">
              <AgencyCountCard
                title="Total Customer Count"
                :count="count.totalCustomerCount"
              />
            </div>
          </div>
          <div class="mt-2">
            <div ref="totalDepositAmount">
              <AgencyCountCard
                title="Total Deposit Amount"
                :count="count.totalDepositAmount"
              />
            </div>
          </div>
          <div class="mt-2">
            <div ref="totalWithrawalAmount">
              <AgencyCountCard
                title="Total Withrawal Amount"
                :count="count.totalWithrawalAmount"
              />
            </div>
          </div>
        </div>
        <div class="col-sm-12 col-md-8">
          <!-- <h6>2. Select a service</h6> -->

          <vs-button href="/user/dashboard/agency-banking/customers" primary>
            View Customers
          </vs-button>
          <vs-button href="/user/dashboard/agency-banking/transactions" primary>
            View Transactions
          </vs-button>
          <div class="choose-transfer-type-card p-4">
            <div class="saved-beneficiary mt-3">
              <a
                class="mx-2 text-decoration-none text-dark"
                href="/user/dashboard/transfer"
              >
                <div class="card-links">Deposit</div>
              </a>
              <a
                class="mx-2 text-decoration-none text-dark"
                href="/user/dashboard/agency-banking/withdraw"
              >
                <div class="card-links">Withdrawal</div>
              </a>
              <div
                class="card-links text-center"
                @click="createClientAccount()"
              >
                Create Account
              </div>
            </div>

            <div class="w-50">
              <div class="input-group my-4">
                <input
                  type="text"
                  class="form-control"
                  placeholder="Referral Code"
                  :value="refferalCode"
                  disabled
                  id="refferalCode"
                />
                <button
                  class="btn btn-primary"
                  type="button"
                  @click="copyReferralCode"
                >
                  Copy Referral Code
                </button>
              </div>
              <div class="input-group my-4">
                <input
                  type="text"
                  class="form-control"
                  placeholder="Referral Link"
                  :value="referalLink"
                  disabled
                  id="refferalLink"
                />
                <button
                  class="btn btn-primary"
                  type="button"
                  @click="copyReferralLink"
                >
                  Copy Referral Link
                </button>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  components: {},
  layout: 'dashboard',
  data: () => ({
    count: {
      transactionCount: 0,
      totalCustomerCount: 0,
      totalDepositAmount: 0,
      totalWithrawalAmount: 0,
    },
  }),
  computed: {
    user() {
      return this.$store.getters['auth/user']
    },
    refferalCode() {
      return this.user.referalCode
    },
    referalLink() {
      return `${window.location.origin}/auth/open-account/bvn-verification?refferal=${this.user.referalCode}`
    },
  },
  mounted() {
    this.fetchTransactionCountData()
    this.fetchTotalCustomerCountData()
    this.fetchTotalDepositData()
    this.fetchTotalWithdrawalData()
  },
  methods: {
    createClientAccount() {
      // localStorage.removeItem('core-bank-client-v1')
      this.$store.commit('auth/LOGOUT', {
        path: `/auth/open-account/bvn-verification?refferal=${this.user.referalCode}`,
      })
    },
    async fetchTransactionCountData() {
      const loading = this.$vs.loading({
        target: this.$refs.transactionCount,
        color: 'primary',
        scale: 1,
      })
      try {
        this.contentLoading = true
        const { payload } = await this.$axios.$get(
          '/agent/total-transaction-count'
        )
        loading.close()
        // console.log(payload)
        this.count.transactionCount = payload
        this.contentLoading = false
      } catch (error) {
        loading.close()
        this.contentLoading = false
      }
    },
    async fetchTotalCustomerCountData() {
      const loading = this.$vs.loading({
        target: this.$refs.totalCustomerCount,
        color: 'primary',
        scale: 1,
      })
      try {
        this.contentLoading = true
        const { payload } = await this.$axios.$get(
          '/agent/total-customer-count'
        )
        loading.close()
        // console.log(payload)
        this.count.totalCustomerCount = payload
        this.contentLoading = false
      } catch (error) {
        loading.close()
        this.contentLoading = false
      }
    },
    async fetchTotalDepositData() {
      const loading = this.$vs.loading({
        target: this.$refs.totalDepositAmount,
        color: 'primary',
        scale: 1,
      })
      try {
        this.contentLoading = true
        const { payload } = await this.$axios.$get(
          '/agent/total-deposit-amount'
        )
        loading.close()
        // console.log(payload)
        this.count.totalDepositAmount = payload
        this.contentLoading = false
      } catch (error) {
        loading.close()
        this.contentLoading = false
      }
    },
    async fetchTotalWithdrawalData() {
      const loading = this.$vs.loading({
        target: this.$refs.totalWithrawalAmount,
        color: 'primary',
        scale: 1,
      })
      try {
        this.contentLoading = true
        const { payload } = await this.$axios.$get(
          '/agent/total-withdrawal-amount'
        )
        loading.close()
        // console.log(payload)
        this.count.totalWithrawalAmount = payload
        this.contentLoading = false
      } catch (error) {
        loading.close()
        this.contentLoading = false
      }
    },
    copyReferralCode() {
      const text = document.getElementById('refferalCode')
      text.select()
      window.navigator.clipboard.writeText(text.value)
    },
    copyReferralLink() {
      const text = document.getElementById('refferalLink')
      text.select()
      window.navigator.clipboard.writeText(text.value)
    },
  },
}
</script>

<style lang="scss">
@import '~@/assets/scss/index';
@import '~@/assets/scss/variables';

.text-sm {
  font-size: 12px;
}

.card-links {
  height: 100px;
  width: 100px;
  background: #f0f3f2;
  border-radius: 20px;
  display: flex;
  align-items: center;
  justify-content: center;
  cursor: pointer;
}

.dashboard-agency-banking-page {
  .choose-transfer-type-card,
  .fill-beneficiary-details {
    background: #ffffff;
    border-radius: 20px;

    input.form-control,
    .form-select,
    textarea.form-control {
      background-color: #f4f2ec;
      border-radius: 5px;
      border: none;
    }
  }
}
</style>
